/******************************************************************************
 app_flash_memory.h - flash memory header file 
 Version: 0.9.1
 Created on: 03/07/2021
 Created by: Rohit Rajapure

 Copyright (c) 2017 Shalaka Connected Devices LLP.  All rights reserved.
 Software License Agreement

   Redistribution and use in source and binary forms, with or without
   modification, are not permitted.

   Redistributions of source code must retain the above copyright
   notice, this list of conditions and the following disclaimer.

   Redistributions in binary form must reproduce the above copyright
   notice, this list of conditions and the following disclaimer in the
   documentation and/or other materials provided with the
   distribution.

   Neither the name of Shalaka Connected Devices LLP nor the names of
   its contributors may be used to endorse or promote products derived
   from this software without specific prior written permission.

 THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
******************************************************************************/
#ifndef APP_FLASH_MEMORY_H_
#define APP_FLASH_MEMORY_H_

/******************************************************************************************
*MACROS
*
*******************************************************************************************/
//Flash related MACROS 
#define FLASH_START_ADDRESS           0x3F000
#define FLASH_END_ADDRESS             0x3FFFF

/****************************************************************************
 *
 * NAME: Flashinitialization
 *
 * DESCRIPTION:
 * function for initialization flash memory
 *
 * RETURNS:
 * void
 *
 ****************************************************************************/
void Flashinitialization (void);

/****************************************************************************
 *
 * NAME: EraseFlashMemory
 *
 * DESCRIPTION:
 * function for erasing flash memory
 *
 * RETURNS:
 * void
 *
 ****************************************************************************/
void EraseFlashMemory (void);

/****************************************************************************
 *
 * NAME: ReadFlashMemory
 *
 * DESCRIPTION:
 * function for read data from flash memory
 *
 * RETURNS:
 * void
 *
 ****************************************************************************/
 void ReadFlashMemory (void);
 
 /****************************************************************************
 *
 * NAME: WriteFlashMemory
 *
 * DESCRIPTION:
 * function for write data to flash memory
 *
 * RETURNS:
 * void
 *
 ****************************************************************************/
 void WriteFlashMemory (void);
 
#endif /* APP_FLASH_MEMORY_H_*/