/******************************************************************************
 commands.c - rtc header file 
 Version: 0.9.1
 Created on: 21/06/2021
 Created by: Rohit Rajapure

 Copyright (c) 2017 Shalaka Connected Devices LLP.  All rights reserved.
 Software License Agreement

   Redistribution and use in source and binary forms, with or without
   modification, are not permitted.

   Redistributions of source code must retain the above copyright
   notice, this list of conditions and the following disclaimer.

   Redistributions in binary form must reproduce the above copyright
   notice, this list of conditions and the following disclaimer in the
   documentation and/or other materials provided with the
   distribution.

   Neither the name of Shalaka Connected Devices LLP nor the names of
   its contributors may be used to endorse or promote products derived
   from this software without specific prior written permission.

 THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
******************************************************************************/
#ifndef THERMOSTAT_SOURCE_APP_RTC_H_
#define THERMOSTAT_SOURCE_APP_RTC_H_

/****************************************************************************/
/***        Include files                                                 ***/
/****************************************************************************/

/****************************************************************************/
/***        Macro Definitions                                             ***/
/****************************************************************************/
// Past days from 2000 to 2017
#define DAYS_SINCE_2000_TO_2017			6210
/// Number of days in the month of January
#define JAN				31
/// Number of days in the month of February
#define FEB 		   	28
/// Number of days in the month of March
#define MAR   			31
/// Number of days in the month of April
#define APR				30
/// Number of days in the month of May
#define MAY				31
/// Number of days in the month of June
#define JUN				30
/// Number of days in the month of July
#define JUL				31
/// Number of days in the month of August
#define AUG				31
/// Number of days in the month of September
#define SEPT			        30
/// Number of days in the month of October
#define OCT				31
/// Number of days in the month of November
#define NOV				30
/// Number of days in the month of December
#define DEC				31

/// Days (only for module RTC)
#define SUN 0
#define MON 1
#define TUE 2
#define WEN 3
#define THU 4
#define FRI 5
#define SAT 6
/*----------------------------------------------------------------------------*/
/* Structs                                                                    */
/*----------------------------------------------------------------------------*/
typedef struct
{
    // year
    uint16_t YEAR;
    // Month
    uint8_t MONTH;
    // Day
    uint8_t DAY;
    // Weekday
    uint8_t WEEKDAY;
    // Hour
    uint8_t HOUR;
    // Minute
    uint8_t MINUTE;
    // Seconds
    uint8_t SECOND;
} S_Date;

/****************************************************************************/
/***        Type Definitions                                              ***/
/****************************************************************************/
/****************************************************************************/
/***        Local Function Prototypes                                     ***/
/****************************************************************************/
/****************************************************************************/
/***        External Variables                                            ***/
/****************************************************************************/
extern uint8_t ui8RTCArray [6];
/****************************************************************************/
/***        Local Variables                                               ***/
/****************************************************************************/
/****************************************************************************/
/***        External Functions                                            ***/
/****************************************************************************/
void vRTC_CalculateRTC(uint32_t ui32UTCSeconds);
void vRTC_vRequestTimeFromCoordiantor(void);
/*----------------------------------------------------------------------------*/
/* Name : RTC_calcActualDay( void )                                           */
/* Description: Returns the current day of the week.                         */
/*----------------------------------------------------------------------------*/
uint8_t ui8RTC_getActualDay( void );
/****************************************************************************/
/***        END OF FILE                                                   ***/
/****************************************************************************/
#endif /* THERMOSTAT_SOURCE_APP_RTC_H_ */
