/******************************************************************************
 timer_config.h - nRF52840 timer configuration API Header file for ACK_TIME_OUT and COMMUNICATION_TIMEOUT
 Version: 0.9.1
 Created on: 07/04/2021
 Created by: Rohit Rajapure

 Copyright (c) 2017 Shalaka Connected Devices LLP.  All rights reserved.
 Software License Agreement

   Redistribution and use in source and binary forms, with or without
   modification, are not permitted.

   Redistributions of source code must retain the above copyright
   notice, this list of conditions and the following disclaimer.

   Redistributions in binary form must reproduce the above copyright
   notice, this list of conditions and the following disclaimer in the
   documentation and/or other materials provided with the
   distribution.

   Neither the name of Shalaka Connected Devices LLP nor the names of
   its contributors may be used to endorse or promote products derived
   from this software without specific prior written permission.

 THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 ******************************************************************************/
#ifndef TIMER_CONFIG_H_
#define TIMER_CONFIG_H_

/******************************************************************************************
*INSTANCE CREATION
*
*******************************************************************************************/

/******************************************************************************************
*MACROS
*
*******************************************************************************************/
#define ACK_TIMEOUT_PERIOD      1500          /**< Timer period. ACK_TIMEOUT timer will expire after 500 ms */

/******************************************************************************************
*TYPEDEF
*
*******************************************************************************************/

/******************************************************************************************
*FUNCTIONS
*
*******************************************************************************************/
/******************************************************************************************
*Peripheral timer 2 configuration function
*return void
*******************************************************************************************/
void timer_config_func(void);

/******************************************************************************************
*Timer configuration function
* @parameter time_out period
*return void
*******************************************************************************************/
void ack_timer_start_func(uint32_t ui32TimeOut);

/******************************************************************************************
*Peripheral timer 2 stop function
*return void
*******************************************************************************************/
void ack_timer_stop_func(void);


#endif /* TIMER_CONFIG_H_ */